<template>
   <b-container>
    <h5 class="text-second mb-3 mt-3"><b-icon icon="pentagon"></b-icon> &nbsp;Contours</h5>
    <b-row class="mb-3">
      <b-col cols="4">
        <label class="col-form-label">Type</label>
      </b-col>
      <b-col cols="8">
        <b-select value-field="item"
        text-field="name" v-on:change="onChangeType($event)"
        :value="pattern" :options="motifList"></b-select>
      </b-col>
    </b-row>
    <FormTextInput v-bind:label="'Couleur de Trait'" :colorPicker="true"
    @inputChange="inputChange()"
    v-model="strokeStyle.color" :placeholder="strokeStyle.baseStyle.color"/>

    <SymbolStyleDefinition v-if="hasMotif"
      @symboChange="inputChange()"
      :symbol="strokeStyle.symbol"
      :type="strokeStyle.pattern"/>
    <FormTextInput v-if="hasMotif"
      @inputChange="inputChange()"
      v-bind:label="'Decalage entre les symboles'"
      v-model="strokeStyle.patternMargin"
      :placeholder="strokeStyle.baseStyle.patternMargin"/>
    <FormTextInput v-bind:label="'Largeur de Trait'"
      @inputChange="inputChange()"
      v-model="strokeStyle.strokeWidth"
      :placeholder="strokeStyle.baseStyle.strokeWidth"/>
    <b-row class="mb-3">
      <b-col  cols="4">
        <label class="col-form-label">Rendu des extrémités</label>
      </b-col>
      <b-col cols="8">
        <b-form-select value-field="item"
          text-field="name" v-on:change="onChangeLineCap($event)"
          :value="lineCap" :options="lineCapList"></b-form-select>
      </b-col>
    </b-row>
    <b-row class="mb-3">
      <b-col  cols="4">
          <label>Rendu des jointures de segments</label>
      </b-col>
      <!-- <b-form-select value-field="item"
        text-field="name" v-on:change="onChangeLineJoin($event)"
        :value="lineJoin" :options="lineJoinList"></b-form-select>
        -->
        <b-col cols="8">
          <v-select :options="lineJoinList" label="name"
          v-model="lineJoin" @input="onChangeLineJoin($event)"
            :clearable="false">
            <template v-slot:option="option">
              <span :class="option.id"></span>
              {{ option.name }}
            </template>
          </v-select>
        </b-col>
    </b-row>
    <FormTextInput v-bind:label="'Motif des Tirets'"
    :tooltip="'Exprime un motif de tirets par une série de nombres séparés\
     par des espaces.le premier nombre représente\
     la longeur d un tiret en pixels, le second la longeur du blanc,\
     et ainsi de suite.Ex: 4 2 pour des tirets,\
      2 2 pour des pointillés, 4 2 2 2 pour Tirets-Pointillé'"
      v-model="strokeStyle.lineDash"
      :placeholder="strokeStyle.baseStyle.lineDash"/>
    <FormTextInput v-bind:label="'lineDashOffset'"
      @inputChange="inputChange()"
      v-model="strokeStyle.lineDashOffset"
      :placeholder="strokeStyle.baseStyle.lineDashOffset"/>

   </b-container>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Vue from 'vue';
import SymbolStyleDefinition from '@/components/layers/style/SymbolStyleDefinition.vue';
import FormTextInput from '@/components/shared/FormTextInput.vue';
import StrokeStyle from '@/models/map-context/style/StrokeStyle';
import Component from 'vue-class-component';

@Component({
  props: {
    strokeStyle: StrokeStyle,
  },
  components: {
    SymbolStyleDefinition,
    FormTextInput,
  },
})
export default class StrokeStyleDefinition extends Vue {
  strokeStyle!:StrokeStyle;

  motifList=StrokeStyle.PATTERN_TYPES;

  lineCapList=StrokeStyle.LINECAP_TYPES;

  lineJoinList=StrokeStyle.LINEJOIN_TYPES;

  lineJoin=this.lineJoinList.find((x) => x.id === this.strokeStyle.getLineJoin());

  get hasMotif() {
    return this.strokeStyle.pattern !== undefined
    && this.strokeStyle.pattern !== ''
    && this.strokeStyle.pattern !== 'simple';
  }

  get pattern() {
    return this.strokeStyle.getPattern();
  }

  onChangeType(event:any) {
    this.strokeStyle.pattern = event;
  }

  get lineCap() {
    return this.strokeStyle.getLineCap();
  }

  onChangeLineCap(event:any) {
    this.strokeStyle.lineCap = event;
  }

  onChangeLineJoin(event:any) {
    console.log('change LineJoin');
    this.strokeStyle.lineJoin = event.id;
    this.inputChange();
  }

  inputChange() {
    this.$emit('symboChange', '');
  }
}
</script>

<style scoped lang="less">
.v-select{min-width: 150px;width:100%}

.miter:before {
    background-image: url("/styles/linejoin/miter.png");
    background-repeat: no-repeat;
    background-size: 20px 20px;
    display: inline-block;
    width: 20px;
    height: 20px;
    content:"";
}
.round:before {
    background-image: url("/styles/linejoin/round.png");
    background-repeat: no-repeat;
    background-size: 20px 20px;
    display: inline-block;
    width: 20px;
    height: 20px;
    content:"";
}
.bevel:before {
    background-image: url("/styles/linejoin/bevel.png");
    background-repeat: no-repeat;
    background-size: 20px 20px;
    display: inline-block;
    width: 20px;
    height: 20px;
    content:"";
}
</style>
